## radare2 0.9.6

=== Makefile ===
-include config-user.mk
include global.mk

DLIBDIR=$(DESTDIR)/$(LIBDIR)
R2BINS=$(shell cd binr ; echo r*2)
DATADIRS=libr/cons/d libr/asm/d libr/syscall/d libr/magic/d
#binr/ragg2/d
STRIP?=strip
#ifneq ($(shell bsdtar -h 2>/dev/null|grep bsdtar),)
ifneq ($(shell xz --help 2>/dev/null|grep improve),)
TAR=tar -cvf
TAREXT=tar.xz
CZ=xz -f
else
TAR=bsdtar cvf
TAREXT=tar.gz
CZ=gzip -f
endif
PWD=$(shell pwd)

all: plugins.cfg
	${MAKE} -C libr/util
	${MAKE} -C shlr
	${MAKE} -C libr
	${MAKE} -C binr

plugins.cfg:
	@if [ ! -e config-user.mk ]; then echo ; \
	echo "  Please, run ./configure first" ; echo ; exit 1 ; fi
	./configure-plugins

w32:
	sys/mingw32.sh

.PHONY: depgraph.png
depgraph.png:
	cd libr ; perl depgraph.pl | dot -Tpng -odepgraph.png

android:
	@if [ -z "$(NDK_ARCH)" ]; then echo "Set NDK_ARCH=[arm|mips|x86]" ; false; fi
	sys/android-${NDK_ARCH}.sh

w32dist:
	rm -rf radare2-w32-${VERSION} w32dist
	mkdir w32dist
	for a in `find libr | grep -e dll$$`; do cp $$a w32dist ; done
	for a in `find binr | grep -e exe$$`; do cp $$a w32dist ; done
	rm -f w32dist/plugin.dll
	mkdir -p w32dist/radare2/${VERSION}/magic
	cp -f libr/magic/d/default/* w32dist/radare2/${VERSION}/magic
	mkdir -p w32dist/radare2/${VERSION}/syscall
	cp -f libr/syscall/d/*.sdb w32dist/radare2/${VERSION}/syscall
	mkdir -p w32dist/radare2/${VERSION}/opcodes
	cp -f libr/asm/d/*.sdb w32dist/radare2/${VERSION}/opcodes
	mkdir -p w32dist/share/doc/radare2
	mkdir -p w32dist/include/libr
	cp libr/include/*.h w32dist/include/libr
	#mkdir -p w32dist/include/libr/sflib
	cp -f doc/fortunes w32dist/share/doc/radare2
	mv w32dist radare2-w32-${VERSION}
	rm -f radare2-w32-${VERSION}.zip 
	zip -r radare2-w32-${VERSION}.zip radare2-w32-${VERSION}

clean:
	for a in shlr libr binr ; do (cd $$a ; ${MAKE} clean) ; done

distclean mrproper:
	for a in libr binr shlr ; do ( cd $$a ; ${MAKE} mrproper) ; done
	rm -f config-user.mk plugins.cfg libr/config.h
	rm -f libr/include/r_userconf.h libr/config.mk
	rm -f pkgcfg/*.pc

pkgcfg:
	cd libr && ${MAKE} pkgcfg

install-man:
	mkdir -p ${MDR}/man1
	for a in man/*.1 ; do ${INSTALL_MAN} $$a ${MDR}/man1 ; done
	cd ${MDR}/man1 && ln -fs radare2.1 r2.1

install-man-symlink:
	mkdir -p ${MDR}/man1
	cd man && for a in *.1 ; do ln -fs ${PWD}/man/$$a ${MDR}/man1/$$a ; done
	cd ${MDR}/man1 && ln -fs radare2.1 r2.1

install-doc:
	${INSTALL_DIR} ${PFX}/share/doc/radare2
	for a in doc/* ; do ${INSTALL_DATA} $$a ${PFX}/share/doc/radare2 ; done

install-doc-symlink:
	${INSTALL_DIR} ${PFX}/share/doc/radare2
	cd doc ; for a in * ; do \
		ln -fs ${PWD}/doc/$$a ${PFX}/share/doc/radare2 ; done

install: install-doc install-man install-www
	cd libr && ${MAKE} install PARENT=1 PREFIX=${PREFIX} DESTDIR=${DESTDIR}
	cd binr && ${MAKE} install PREFIX=${PREFIX} DESTDIR=${DESTDIR}
	cd shlr && ${MAKE} install PREFIX=${PREFIX} DESTDIR=${DESTDIR}
	for a in ${DATADIRS} ; do \
	(cd $$a ; ${MAKE} install LIBDIR=${LIBDIR} PREFIX=${PREFIX} DESTDIR=${DESTDIR} ); \
	done
	mkdir -p ${DLIBDIR}/radare2/${VERSION}/hud
	cp -f doc/hud ${DLIBDIR}/radare2/${VERSION}/hud/main
	cp ${PWD}/libr/lang/p/radare.lua ${DLIBDIR}/radare2/${VERSION}/radare.lua
	sys/ldconfig.sh

install-www:
	rm -rf ${DESTDIR}/${WWWROOT}
	rm -rf ${DLIBDIR}/radare2/${VERSION}/www # old dir
	mkdir -p ${DESTDIR}/${WWWROOT}
	cp -rf shlr/www/* ${DESTDIR}/${WWWROOT}

symstall-www:
	rm -rf ${DESTDIR}/${WWWROOT}
	rm -rf ${DLIBDIR}/radare2/${VERSION}/www # old dir
	mkdir -p ${DESTDIR}/${WWWROOT}
	cd ${DESTDIR}/${WWWROOT} ; for a in ${PWD}/shlr/www/* ; do \
		ln -fs $$a ${DESTDIR}/${DATADIR}/radare2/${VERSION}/www ; done

install-pkgconfig-symlink:
	@${INSTALL_DIR} ${DLIBDIR}/pkgconfig
	cd pkgcfg ; for a in *.pc ; do ln -fs $${PWD}/$$a ${DLIBDIR}/pkgconfig/$$a ; done

symstall install-symlink: install-man-symlink install-doc-symlink install-pkgconfig-symlink symstall-www
	cd libr && ${MAKE} install-symlink PREFIX=${PREFIX} DESTDIR=${DESTDIR}
	cd binr && ${MAKE} install-symlink PREFIX=${PREFIX} DESTDIR=${DESTDIR}
	cd shlr && ${MAKE} install-symlink PREFIX=${PREFIX} DESTDIR=${DESTDIR}
	for a in ${DATADIRS} ; do (\
		cd $$a ; \
		echo $$a ; \
		${MAKE} install-symlink LIBDIR=${LIBDIR} PREFIX=${PREFIX} DESTDIR=${DESTDIR} ); \
	done
	mkdir -p ${DLIBDIR}/radare2/${VERSION}/hud
	ln -fs ${PWD}/doc/hud ${DLIBDIR}/radare2/${VERSION}/hud/main
	ln -fs ${PWD}/libr/lang/p/radare.lua ${DLIBDIR}/radare2/${VERSION}/radare.lua
	sys/ldconfig.sh

deinstall uninstall:
	cd libr && ${MAKE} uninstall PARENT=1 PREFIX=${PREFIX} DESTDIR=${DESTDIR}
	cd binr && ${MAKE} uninstall PARENT=1 PREFIX=${PREFIX} DESTDIR=${DESTDIR}
	cd shlr && ${MAKE} uninstall PARENT=1 PREFIX=${PREFIX} DESTDIR=${DESTDIR}
	cd libr/syscall/d && ${MAKE} uninstall PARENT=1 PREFIX=${PREFIX} DESTDIR=${DESTDIR} LIBDIR=${LIBDIR}
	@echo
	@echo "Run 'make purge' to also remove installed files from previous versions of r2"
	@echo

purge-doc:
	rm -rf ${DESTDIR}/${PREFIX}/share/doc/radare2
	cd man ; for a in *.1 ; do rm -f ${MDR}/man1/$$a ; done
	rm -f ${MDR}/man1/r2.1

purge-dev:
	rm -rf ${DESTDIR}/${LIBDIR}/libr_*.a
	rm -rf ${DESTDIR}/${LIBDIR}/pkgconfig/r_*.pc
	rm -rf ${DESTDIR}/${INCLUDEDIR}/libr
	rm -f ${DESTDIR}/${LIBDIR}/radare2/${VERSION}/-*
	# XXX: this must be in purge-sym ?
	-for a in ${R2BINS} ; do ${STRIP} -s ${DESTDIR}/${BINDIR}/$$a 2> /dev/null ; done
	-for a in ${DESTDIR}/${LIBDIR}/libr_*.so ; do ${STRIP} -s $$a ; done

purge: purge-doc purge-dev
	for a in ${R2BINS} ; do rm -f ${DESTDIR}/${BINDIR}/$$a ; done
	rm -f ${DESTDIR}/${BINDIR}/ragg2-cc
	rm -f ${DESTDIR}/${LIBDIR}/libr_*
	rm -rf ${DESTDIR}/${LIBDIR}/radare2
	rm -rf ${DESTDIR}/${INCLUDEDIR}/libr

dist:
	-[ configure -nt config-user.mk ] && ./configure --prefix=${PREFIX}
	git log $$(git show-ref `git tag |tail -n1`)..HEAD > ChangeLog
	DIR=`basename $$PWD` ; \
	FILES=`git ls-files | sed -e s,^,radare2-${VERSION}/,` ; \
	cd .. && mv $${DIR} radare2-${VERSION} && \
	${TAR} radare2-${VERSION}.tar $${FILES} radare2-${VERSION}/ChangeLog ;\
	${CZ} radare2-${VERSION}.tar ; \
	mv radare2-${VERSION} $${DIR}

shot:
	DATE=`date '+%Y%m%d'` ; \
	FILES=`git ls-files | sed -e s,^,radare2-${DATE}/,` ; \
	cd .. && mv radare2 radare2-$${DATE} && \
	${TAR} radare2-$${DATE}.tar $${FILES} ;\
	${CZ} radare2-$${DATE}.tar ;\
	mv radare2-$${DATE} radare2 && \
	scp radare2-$${DATE}.${TAREXT} \
		radare.org:/srv/http/radareorg/get/shot

tests:
	@if [ -d r2-regressions ]; then \
		cd r2-regressions ; git clean -xdf ; git pull ; \
	else \
		git clone git://github.com/radare/r2-regressions.git ; \
	fi
	cd r2-regressions ; ${MAKE}

include ${MKPLUGINS}

.PHONY: all clean distclean mrproper install symstall uninstall deinstall dist shot pkgcfg
.PHONY: r2-bindings r2-bindings-dist libr binr install-man w32dist tests

=== binr/Makefile ===
include ../global.mk
BTOP=$(shell pwd)

.PHONY: all clean install install-symlink deinstall uninstall mrproper

PFX=${DESTDIR}/${PREFIX}
BFX=${DESTDIR}/${BINDIR}
LFX=${DESTDIR}/${LIBDIR}

BINS=rax2 rasm2 rabin2 rahash2 radiff2 radare2 rafind2 rarun2 ragg2 r2agent

all:
	@for a in ${BINS} ; do (cd $$a && ${MAKE} all) || exit 1; done

install:
	mkdir -p ${BFX}
	for a in ${BINS} ; do ${INSTALL_PROGRAM} $$a/$$a ${BFX}/$$a ; done
	${INSTALL_SCRIPT} ragg2/ragg2-cc ${BFX}/ragg2-cc
	-cd ${BFX} && rm -f r2 ; ln -fs radare2 r2

symstall install-symlink:
	mkdir -p ${BFX}
	for a in ${BINS} ; do ln -fs ${BTOP}/$$a/$$a ${BFX}/$$a ; done
	ln -fs ${BTOP}/ragg2/ragg2-cc ${BFX}/ragg2-cc
	-ln -fs ${PFX}/bin/radare2 ${BFX}/r2

deinstall uninstall:
	for a in ${BINS} ; do rm -f ${BFX}/$$a ; done
	-rm -f ${BFX}/r2

clean:
	@for a in ${BINS} ; do (cd $$a && ${MAKE} clean); done

mrproper:
	@for a in ${BINS} ; do (cd $$a && ${MAKE} mrproper); done

=== build/Makefile ===
T=all install clean util cons reg db sdb libr binr shlr
.PHONY: ${T}
${T}:
	@node radare2.js $@

=== libr/Makefile ===
include ../global.mk
include config.mk
include ../mk/${COMPILER}.mk

PREFIX?=${PWD}/../prefix
PFX=${DESTDIR}/${PREFIX}
LFX=${DESTDIR}/${LIBDIR}
IFX=${DESTDIR}/${INCLUDEDIR}
PWD=$(shell pwd)

LIBS0=util hash
LIBS1=reg cons db magic lib diff bp search config socket
LIBS2=syscall cmd lang io crypto flags bin
LIBS3=fs anal
LIBS4=parse sign
LIBS5=asm debug
LIBS6=egg
#LIBS6+=print
LIBS7=core

LIBS=$(LIBS0) $(LIBS1) $(LIBS2) $(LIBS3) $(LIBS4) $(LIBS5) $(LIBS6) $(LIBS7)
.PHONY: $(LIBS)

all:
	${MAKE} $(LIBS0)
	${MAKE} $(LIBS1)
	${MAKE} $(LIBS2)
	${MAKE} $(LIBS3)
	${MAKE} $(LIBS4)
	${MAKE} $(LIBS5)
	${MAKE} $(LIBS6)
	${MAKE} $(LIBS7)
ifeq (${WITHNONPIC},1)
	${MAKE} libr.a
endif

# looks hacky :D
#AR=arm-linux-androideabi-ar
libr.a:
	rm -rf .libr
	mkdir .libr
	for a in */libr_*.a ; do \
		mkdir -p .libr/$$a ; \
		cp -f $$a .libr/$$a ; \
		(cd .libr/$$a ; ${AR} x *.a ; rm -f *.a ) ; \
		done
	${AR} qv libr.a `find .libr/ | grep '\\.o$$'`
	rm -rf .libr

gnu_libr.a: $(shell ls */libr_*.a 2>/dev/null)
	rm -f libr.a
	echo CREATE libr.a > libr.m
	for a in */libr_*.a ; do echo ADDLIB $$a >> libr.m ; done
	echo SAVE >> libr.m
	# ar -M is a gnu-ism .. try to find a proper portable way to do that
	${CC_AR} -M < libr.m
	rm -f libr.m

$(LIBS):
	@echo "DIR $@"
	@${MAKE} -C $@

pkgcfg:
	@for lib in ${LIBS}; do ( cd $${lib} && ${MAKE} pkgcfg ); done
	cd asm && ${MAKE} pkgcfg NAME=libr DEPS="r_`echo ${LIBS}|sed -e 's, , r_,g'`"
	# TODO: Magically generate libr.pc.acr here using LIBS and so :)

install-pkgconfig:
	${INSTALL_DIR} ${LFX}/pkgconfig
	for a in ../pkgcfg/*.pc ; do ${INSTALL_DATA} $$a ${LFX}/pkgconfig ; done

install-includes:
	${INSTALL_DIR} ${IFX}/libr
	(cd include && for a in *.h ; do ${INSTALL_DATA} $$a ${IFX}/libr ; done)
	${INSTALL_DIR} ${IFX}/libr/sflib
	(cd include/sflib && for a in * ; do \
		${INSTALL_DIR} ${IFX}/libr/sflib/$$a ; \
		for b in $$a/*.h ; do \
			${INSTALL_DATA} $$b ${IFX}/libr/sflib/$$b ; \
		done ; \
	done)
	${INSTALL_DIR} ${IFX}/libr/sdb
	(cd include/sdb && for a in * ; do \
		${INSTALL_DATA} $$a ${IFX}/libr/sdb/$$a ; \
	done)

symstall install-symlink:
	mkdir -p ${PFX}/bin ${IFX} ${LFX}/pkgconfig ${LFX}/radare2/${VERSION}
	rm -rf ${IFX}/libr && ln -fs ${PWD}/include ${IFX}/libr
	cd ../pkgcfg && for a in *.pc ; do \
		if [ -e ${PWD}/../pkgcfg/$${a} ] ; then \
			ln -fs ${PWD}/../pkgcfg/$${a} ${LFX}/pkgconfig/$${a} ; \
		fi ; \
	done
	for a in ${LIBS} ; do \
		ln -fs ${PWD}/$${a}/libr_$${a}.${EXT_SO} ${LFX}/libr_$${a}.${EXT_SO} ; \
		ln -fs ${PWD}/$${a}/libr_$${a}.${EXT_SO} ${LFX}/libr_$${a}.${EXT_SO}.${LIBVERSION} ; \
		ln -fs ${PWD}/$${a}/libr_$${a}.${EXT_AR} ${LFX}/libr_$${a}.${EXT_AR} ; \
		for b in $${a}/p/*.${EXT_SO} ; do \
			if [ -e ${PWD}/$${b} ] ; then \
				ln -fs ${PWD}/$${b} ${LFX}/radare2/${VERSION}/ ; \
			fi ; \
		done ; \
		( cd ${LFX}/radare2 ; ln -fs ${VERSION} last ) ; \
	done

install: install-includes install-pkgconfig
	# TODO :Use INSTALL_DATA_DIR instead of mkdir
	# libraries
	@${INSTALL_DIR} ${LFX}
	@for a in `find * -type f | grep -e '\.${EXT_SO}$$' | grep -v lib/t | grep lib | grep -v /p/` ; do \
	  b=`echo $$a|cut -d / -f 2`; \
	  echo " ${LFX}/$$b.${LIBVERSION}"; \
	  ${INSTALL_LIB} $$a ${LFX}/$$b.${LIBVERSION} ; \
	  ( cd ${LFX} ; ln -fs $$b.${LIBVERSION} $$b ) ; \
	done
	# object archives
	@for a in `find * -type f | grep -e '\.a$$' | grep -v fs/p` ; do \
	  echo " ${LFX}/$$a"; ${INSTALL_DATA} $$a ${LFX} ; done
	# plugins
	@${INSTALL_DIR} ${LFX}/radare2/${VERSION}
	@for a in `find */p -perm -u+x -type f | grep -v exe | grep -v dll | grep ${EXT_SO}`; \
	  do echo " ${LFX}/radare2/${VERSION}/$$a"; \
	${INSTALL_DATA} $$a ${LFX}/radare2/${VERSION} ; done
	@echo "lang/p/radare.* ${DESTDIR}/${PFX}/${LIBDIR}/radare2/${VERSION}"
	${INSTALL_DATA} lang/p/radare.* ${LFX}/radare2/${VERSION}
	cd ${LFX}/radare2 ; ln -fs ${VERSION} last

deinstall uninstall:
	# libraries
	-@for a in `find * | grep -e '\.${EXT_SO}$$' | grep -v 'lib/t' | grep lib` ; do \
	a=`echo $$a | awk -F / '{ print $$NF; }'`; \
	echo ${LFX}/$$a ; rm -f ${LFX}/$$a ; done
	# object archives
	-@for a in `find * | grep -e '\.a$$'` ; do \
	a=`echo $$a | awk -F / '{ print $$NF; }'`; \
	echo ${LFX}/$$a ; rm -f ${LFX}/$$a ; done
	# includes
	-if [ -h ${IFX}/libr ]; then \
		rm -f ${IFX}/libr ; \
	else \
		(cd include && for a in * ; do rm -f ${IFX}/libr/$$a ; done) ; \
	fi
	# programs
	-@for a in `find */t -perm -u+x -type f | grep 2`; do \
	a=`echo $$a|awk -F / '{ print $$NF; }'`; \
	echo ${PFX}/bin/$$a ; rm -f ${PFX}/bin/$$a ; done
	# plugins
	-@for a in `find */p -perm -u+x -type f`; do \
	a="${LFX}/radare2/${VERSION}/`echo $$a|awk -F / '{ print $$NF; }'`"; \
	echo $$a ; rm -f $$a ; done
	rm -rf ${LFX}/radare2/${VERSION}
	rm -f ${LFX}/pkgconfig/libr.pc
	rm -f ${LFX}/pkgconfig/r_*.pc
	# test programs
	rm -rf ${PFX}/bin/libr-test
	# TODO: use for a in LIBS (like in binr/Makefile)
	rm -rf ${IFX}/libr
	rm -rf ${LFX}/libr_*.so.${LIBVERSION}
	rm -rf ${LFX}/libr_*.so.0
	rm -rf ${LFX}/libr_*.so
	rm -rf ${LFX}/libr_*.a
	rm -rf ${LFX}/libr2.so*
	rm -rf ${LFX}/libr2.a
	rm -rf ${LFX}/libr.so*
	rm -rf ${LFX}/libr.a
	rm -rf ${DESTDIR}${DATADIR}/share/doc/radare2
	@echo libr aka radare2 has been uninstalled from PREFIX=${PFX}

clean:
	for lib in ${LIBS}; do ( cd $${lib} && ${MAKE} clean ); done

mrproper:
	for lib in ${LIBS}; do ( cd $${lib} && ${MAKE} mrproper ); done

.PHONY: sloc mrproper clean pkgcfg install deinstall uninstall libr
.PHONY: install-includes install-pkgconfig install-symlink all

=== pkgcfg/Makefile ===
all:
	cd ../libr && ${MAKE} pkgcfg

=== r2-bindings/Makefile ===
# Requires ./configure
include config.mk

PREFIX?=/usr
PYTHON2_CONFIG=python2.7-config
PYTHON3_CONFIG=python3.2-config

ifneq ($(shell bsdtar -h 2>/dev/null|grep bsdtar),)
TAR=bsdtar czvf
else
TAR=tar -czvf
endif

W32PY="${HOME}/.wine/drive_c/Python27/"

ifneq ($(shell grep valac supported.langs 2>/dev/null),)
INSTALL_TARGETS=install-vapi
else
INSTALL_TARGETS=
endif

LANGS=
# Experimental:
# LANGS+=gir
ALANGS=awk gir python ruby perl lua go java guile php5
.PHONY: ${ALANGS}

define ADD_lang
ifneq ($(shell grep $(1) supported.langs 2>/dev/null),)
LANGS+=$(1)
INSTALL_TARGETS+=install-$(1)
endif
endef

ifneq ($(shell grep python supported.langs 2>/dev/null),)
INSTALL_EXAMPLE_TARGETS+=install-python-examples
endif

$(foreach p,${ALANGS},$(eval $(call ADD_lang,$(p))))

.PHONY: ${INSTALL_TARGETS} ${INSTALL_EXAMPLE_TARGETS} ${LANG}

ifeq ($(DEVEL_MODE),1)
LANGS=$(shell cat supported.langs 2>/dev/null)
all: supported.langs
	@for a in ${LANGS} ; do \
		[ $$a = valac ] && continue; \
		(cd $$a && ${MAKE} ) ; done

supported.langs:
	CC=${CC} CXX=${CXX} sh check-langs.sh
else
# compile more
all: supported.langs python lua gir
supported.langs:
	CC=${CC} CXX=${CXX} sh check-langs.sh force-all
endif

chect:
	rm -f supported.langs
	${MAKE} supported.langs

check-w32:
	if [ ! -d "${W32PY}/libs" ]; then \
		wget http://www.python.org/ftp/python/2.7/python-2.7.msi ; \
		msiexec /i python-2.7.msi ; \
	fi

w32:
	cd python && ${MAKE} w32

DSTNAME=radare2-bindings-w32-$(VERSION)
DST=../$(DSTNAME)/Python27/Lib/site-packages/r2
SJLJ=/usr/i486-mingw32/bin/libgcc_s_sjlj-1.dll
STDC=/usr/i486-mingw32/bin/libstdc++-6.dll

w32dist:
	rm -rf ../${DSTNAME}
	mkdir -p ${DST}
	cp -f python/*.dll ${DST}
	cp -f python/r_*.py ${DST}
	:> ${DST}/__init__.py
	cd ${DST} ; for a in *.dll ; do mv $$a `echo $$a | sed -e s,dll,pyd,g` ; done
	# Copy missing libraries
	-cp -f ${SJLJ} ${DST}
	-cp -f ${STDC} ${DST}
	cd .. ; zip -r $(DSTNAME).zip $(DSTNAME)

.PHONY: w32dist dist w32 check check-w32 vdoc vdoc_pkg

dist:
	PKG=r2-bindings-${VERSION} ; \
	DIR=`basename $$PWD` ; \
	FILES=`git ls-files | sed -e s,^,r2-bindings-${VERSION}/,` ; \
	CXXFILES=`cd .. ; find r2-bindings | grep -e cxx$$ -e py$$ | sed -e "s,r2-bindings/,$${PKG}/,"` ; \
	cd .. && mv $${DIR} $${PKG} && \
	echo $$FILES ; \
	${TAR} $${PKG}.tar.gz $${FILES} $${CXXFILES} ; \
	mv $${PKG} $${DIR}

# TODO: valadoc
vdoc:
	-rm -rf vdoc
	cat vapi/r_*.vapi > libr.vapi
	valadoc --package-version=${VERSION} --package-name=libr -o vdoc libr.vapi
	sed -e 's,font-family:.*,font-family:monospace;,' vdoc/style.css > vdoc/.style.css
	mv vdoc/.style.css vdoc/style.css
	-rm -f libr.vapi
	# rsync -avz vdoc/* pancake@radare.org:/srv/http/radareorg/vdoc/

vdoc_pkg:
	rm -rf vdoc
	valadoc -o vdoc vapi/*.vapi
	# rsync -avz vdoc/* pancake@radare.org:/srv/http/radareorg/vdoc/

# TODO: unspaguetti this targets
.PHONY: python2 python3
python2:
	@-[ "`grep python supported.langs`" ] && ( cd python && ${MAKE} PYTHON_CONFIG=${PYTHON2_CONFIG}) || true

python3:
	@-[ "`grep python supported.langs`" ] && ( cd python && ${MAKE} PYTHON_CONFIG=${PYTHON3_CONFIG}) || true

${ALANG}::
	cd $@ && ${MAKE}

go::
	@-[ -x "${GOBIN}/5g" -o -x "${GOBIN}/6g" -o -x "${GOBIN}/8g" ]

test:
	cd perl && ${MAKE} test
	cd python && ${MAKE} test
	cd ruby && ${MAKE} test
	cd lua && ${MAKE} test
	cd guile && ${MAKE} test
	cd go && ${MAKE} test
	cd java && ${MAKE} test

PYTHON?=`pwd`/python-wrapper
PYTHON_VERSION?=`${PYTHON} --version 2>&1 | cut -d ' ' -f 2 | cut -d . -f 1,2`
PYTHON_PKGDIR=$(shell ${PYTHON} mp.py)
PYTHON_INSTALL_DIR=${DESTDIR}/${PYTHON_PKGDIR}/r2

.PHONY: purge purge-python install-cxx

purge: purge-python purge-java

install-cxx:
	@echo TODO: install-cxx

purge-java:
	cd java && ${MAKE} purge

purge-python:
	[ -n "${PYTHON_PKGDIR}" ] && \
	rm -rf ${DESTDIR}/${LIBDIR}/python${PYTHON_VERSION}/*-packages/r2
	rm -rf ${PYTHON_INSTALL_DIR}

install-python:
	[ -e python/_r_core.${SOEXT} ] && true
	E=${SOEXT} ; [ `uname` = Darwin ] && E=so ; \
	echo "Installing python${PYTHON_VERSION} r2 modules in ${PYTHON_INSTALL_DIR}" ; \
	mkdir -p ${PYTHON_INSTALL_DIR} ; \
	: > ${PYTHON_INSTALL_DIR}/__init__.py ; \
	cp -rf python/r_*.py python/*.$$E ${PYTHON_INSTALL_DIR}

LUAPATH=$(shell strings `../sys/whereis.sh lua`| grep lib/lua | cut -d ';' -f 2 | grep '.so'  | cut -d '?' -f 1)

LUAPKG=$(shell pkg-config --list-all|awk '/lua|lua-/{print $$1;}')
ifneq (${LUAPKG},)
LUADIR=$(shell pkg-config --variable=INSTALL_CMOD ${LUAPKG})
lua-install install-lua:
	@mkdir -p ${DESTDIR}${LUADIR} ; \
	echo "Installing lua r2 modules... ${DESTDIR}${LUADIR}" ; \
	cp -rf lua/*.so ${DESTDIR}${LUADIR}/
else
lua-install install-lua:
endif

install-go:
	@. ./go/goenv.sh ; \
	if [ -n "$${GOROOT}" -a -n "$${GOOS}" -a -n "$${GOARCH}" ]; then \
		echo "Installing r2 modules in $${GOROOT}/pkg/$${GOOS}_$${GOARCH}" ; \
		cp -f go/*.a go/*.${SOEXT} $${GOROOT}/pkg/$${GOOS}_$${GOARCH} ; \
	else \
		echo "You have to set the following vars: GOROOT, GOOS and GOARCH" ; \
	fi

install-java:
	cd java && ${MAKE} install

install-ruby:
	for a in 1.8 1.9.1; do \
		mkdir -p ${DESTDIR}${PREFIX}/lib/ruby/$$a/r2 ; \
		echo "Installing ruby$$a r2 modules..." ; \
		cp -rf ruby/* ${DESTDIR}${PREFIX}/lib/ruby/$$a/r2 ; \
	done

install-perl:
	# hack for slpm
	if [ -n "`echo ${PREFIX}${DESTDIR}|grep home`" ]; then \
		target=${PREFIX}${DESTDIR}`perl -e 'for (@INC) { print "$$_\n" if /lib(64)?\/perl5/ && !/local/; }'|head -n 1` ; \
	else \
		target=${DESTDIR}`perl -e 'for (@INC) { print "$$_\n" if /lib(64)?\/perl5/ && !/local/; }'|head -n 1` ; \
	fi ; \
	mkdir -p $$target/r2 ; \
	echo "Installing perl r2 modules..." ; \
	cp -rf perl/*.so $$target/r2 ; \
	cp -rf perl/*.pm $$target/r2

install-vapi:
	mkdir -p ${DESTDIR}${PREFIX}/share/vala/vapi
	${INSTALL_DATA} vapi/*.vapi vapi/*.deps ${DESTDIR}${PREFIX}/share/vala/vapi

AWKDIR=${DESTDIR}${PREFIX}/lib/radare2/${VERSION}/awk
install-awk:
	mkdir -p ${AWKDIR}
	sed -e 's,@AWKDIR@,${AWKDIR},g' < awk/r2awk > ${DESTDIR}${PREFIX}/bin/r2awk
	cp -f awk/* ${AWKDIR}/

install-gir:
	cd gir && ${MAKE} install

install-php5 install-guile:
	@echo TODO install-$@

EXAMPLEDIR=${DESTDIR}${PREFIX}/share/radare2-swig

install-examples: ${INSTALL_EXAMPLE_TARGETS}
	mkdir -p ${EXAMPLEDIR}/vala
	cp -rf vapi/t/*.vala vapi/t/*.gs ${EXAMPLEDIR}/vala

install-python-examples:
	mkdir -p ${EXAMPLEDIR}/python
	cp -rf python/test-*.py ${EXAMPLEDIR}/python

install: ${INSTALL_TARGETS}

deinstall uninstall:
	cd vapi/ ; for a in *.vapi *.deps ; do rm -f ${DESTDIR}${PREFIX}/share/vala/vapi/$$a ; done
	rm -rf ${EXAMPLEDIR}

oldtest:
	sh do-swig.sh r_bp
	python test.py

clean:
	@for a in $(LANGS); do \
		if [ -d $$a ]; then \
		echo "Cleaning $$a " ; \
		( cd $$a && ${MAKE} clean ) ; \
		fi ; \
	done

mrproper:
	for a in $(LANGS); do cd $$a ; ${MAKE} mrproper; cd .. ; done

version:
	@echo ${VERSION}

.PHONY: $(LANGS) $(ALANGS)
.PHONY: clean mrproper all vdoc
.PHONY: oldtest test
.PHONY: w32 w32dist check check-w32
.PHONY: deinstall uninstall install version

=== shlr/Makefile ===
include ../config-user.mk
include ../mk/${COMPILER}.mk

HOST_CC?=gcc
MODS=udis86 java tcc
URL=git://github.com/radare/sdb
PWD=$(shell pwd)
SDB_CONFIG=${PWD}/sdb-config.mk

all: sdb/sdb
	@for a in ${MODS} ; do \
		echo ${MAKE} -C $$a ; \
		${MAKE} -C $$a HAVE_VALA= ROOT=${PWD}/../ ; \
	done

clean mrproper:
	rm -f sdb/src/.sdb sdb/sdb
	cd sdb ; ${MAKE} clean
	@for a in ${MODS} ; do ${MAKE} -C $$a clean ; done

$(SDBLIB) sdb/sdb:
	cd sdb ; ${MAKE} src/sdb-version.h
	cd sdb ; ${MAKE} clean
	cd sdb ; \
		${MAKE} clean && \
		${MAKE} CC=${HOST_CC} && \
		cp -f src/sdb src/.sdb
	cd sdb ; ${MAKE} clean
	cd sdb ; ${MAKE} src/sdb-version.h
	cd sdb/src ; ${MAKE} ARCH=xxx RANLIB="${RANLIB}" CFLAGS_SHARED=-fPIC \
		CC="${CC}" AR="${AR}" CFLAGS="${CFLAGS}" LDFLAGS="${LDFLAGS}" libsdb.a
	${RANLIB} sdb/src/libsdb.a
	cp -f sdb/src/.sdb sdb/sdb


.PHONY: sdb-sync sync-sdb sdbclean
F=README.md config.mk src Makefile
SYNCFILES=$(addprefix sdb.vc/,${F})
I=../libr/include

sdb-sync sync-sdb:
	rm -rf sdb sdb.vc
	git clone ${URL} sdb.vc
	mkdir -p sdb
	cp -rf ${SYNCFILES} sdb
	rm -rf sdb.vc $I/sdb
	mkdir -p $I/sdb
	rm -f src/sdb-version.h
	cd sdb ; ${MAKE} src/sdb-version.h
	cp -f sdb/src/*.h $I/sdb
	echo '#include <sdb/sdb.h>' > $I/sdb.h
	mkdir -p sdb/test sdb/memcache
	sed -e 's,HAVE_VALA=,HAVE_VALA=#,' sdb/config.mk > .t
	mv .t sdb/config.mk
	echo all clean mrproper: | tee sdb/test/Makefile > sdb/memcache/Makefile
	git add $I/sdb*
	git add sdb

$(TCCLIB) libr_tcc/libr_tcc.a:
	cd libr_tcc ; ${MAKE}

udis-sync udis86-sync sync-udis sync-udis86:
	cd udis86 ; ${MAKE} sync

tcc-clean tccclean:
	cd libr_tcc ; ${MAKE} clean

CFILES=i386-asm.c i386-gen.c libtcc.c tccasm.c tccelf.c tccgen.c tccpp.c
HFILES=tcc.h i386-asm.h tcclib.h tcctok.h stab.h
HFILES+=elf.h libtcc.h config.h i386-tok.h

# TODO: use mob branch?

.PHONY: sdb-sync sync-sdb sdbclean
tcc-sync sync-tcc:
	rm -rf _
	git clone git://repo.or.cz/tinycc.git _
	cd _ ; ./configure --prefix=${PREFIX}
	mkdir -p tcc
	for a in ${CFILES} ${HFILES} ; do cp -f _/$$a tcc ; done
	cp -f _/VERSION _/COPYING _/stab.def tcc
	git add tcc
	rm -rf _

D=${DESTDIR}/${PREFIX}
install:
	mkdir -p ${D}/lib
	cp -f tcc/libr_tcc* ${D}/lib

install-symlink symstall:
	mkdir -p ${D}/lib
	cd tcc ; for a in libr_tcc* ; do \
		ln -fs `pwd`/$$a ${D}/lib/$$a ; done

uninstall deinstall:
	rm -f ${D}/lib/libr_tcc*

=== binr/blob/Makefile ===
PREFIX?=/usr
DESTDIR?=/

BINS=rabin2 rarun2 rasm2 ragg2 rahash2 rax2 rafind2 radiff2
BINS2=radare2 ${BINS}

include ../../config-user.mk

CFLAGS=-I ../../libr/include/
CFLAGS+=-DLIBDIR="\"${LIBDIR}\""
CFLAGS+=-DR2_BIRTH=\"`date +%Y-%m-%d`\"
CFLAGS+=-DR2_GITTIP=\"$(GIT_TIP)\"
CFLAGS+=-DR2_GITTAP=\"$(GIT_TAP)\"

#ifeq ($(STATIC_BUILD),1)
ifeq ($(WITHNONPIC),1)
LDFLAGS+=../../libr/io/libr_io.a
LDFLAGS+=../../libr/asm/libr_asm.a
LDFLAGS+=../../libr/db/libr_db.a
LDFLAGS+=../../libr/lib/libr_lib.a
LDFLAGS+=../../libr/egg/libr_egg.a
LDFLAGS+=../../libr/core/libr_core.a
LDFLAGS+=../../libr/crypto/libr_crypto.a
LDFLAGS+=../../libr/parse/libr_parse.a
LDFLAGS+=../../libr/anal/libr_anal.a
LDFLAGS+=../../libr/cmd/libr_cmd.a
LDFLAGS+=../../libr/fs/libr_fs.a
LDFLAGS+=../../libr/sign/libr_sign.a
LDFLAGS+=../../libr/magic/libr_magic.a
LDFLAGS+=../../libr/cons/libr_cons.a
LDFLAGS+=../../libr/diff/libr_diff.a
LDFLAGS+=../../libr/syscall/libr_syscall.a
LDFLAGS+=../../libr/flags/libr_flags.a
LDFLAGS+=../../libr/reg/libr_reg.a
LDFLAGS+=../../libr/debug/libr_debug.a
LDFLAGS+=../../libr/search/libr_search.a
LDFLAGS+=../../libr/config/libr_config.a
LDFLAGS+=../../libr/lang/libr_lang.a
LDFLAGS+=../../libr/bp/libr_bp.a
LDFLAGS+=../../libr/hash/libr_hash.a
LDFLAGS+=../../libr/bin/libr_bin.a
LDFLAGS+=../../libr/util/libr_util.a
LDFLAGS+=../../libr/socket/libr_socket.a
# extra libs #
LDFLAGS+=../../libr/fs/p/grub/libgrubfs.a
LDFLAGS+=../../shlr/sdb/src/libsdb.a
LDFLAGS+=-lm
else
LDFLAGS+=-L../../libr/io -lr_io
LDFLAGS+=-L../../libr/bp -lr_bp
LDFLAGS+=-L../../libr/socket -lr_socket
LDFLAGS+=-L../../libr/bin -lr_bin
LDFLAGS+=-L../../libr/reg -lr_reg
LDFLAGS+=-L../../libr/asm -lr_asm
LDFLAGS+=-L../../libr/cmd -lr_cmd
LDFLAGS+=-L../../libr/lib -lr_lib
LDFLAGS+=-L../../libr/egg -lr_egg
LDFLAGS+=-L../../libr/db -lr_db
LDFLAGS+=-L../../libr/core -lr_core
LDFLAGS+=-L../../libr/anal -lr_anal
LDFLAGS+=-L../../libr/diff -lr_diff
LDFLAGS+=-L../../libr/crypto -lr_crypto
LDFLAGS+=-L../../libr/flags -lr_flags
LDFLAGS+=-L../../libr/parse -lr_parse
LDFLAGS+=-L../../libr/fs -lr_fs
LDFLAGS+=-L../../libr/magic -lr_magic
LDFLAGS+=-L../../libr/sign -lr_sign
LDFLAGS+=-L../../libr/syscall -lr_syscall
LDFLAGS+=-L../../libr/util -lr_util
LDFLAGS+=-L../../libr/cons -lr_cons
LDFLAGS+=-L../../libr/hash -lr_hash
LDFLAGS+=-L../../libr/debug -lr_debug
LDFLAGS+=-L../../libr/search -lr_search
LDFLAGS+=-L../../libr/config -lr_config
endif

all: symlinks

symlinks: build
	for a in r2 ${BINS} ; do \
		ln -fs radare2 $$a ; \
	done

clean:
	mv main.c main.k
	mv version.c version.k
	rm -f *.[ch]
	mv main.k main.c
	mv version.k version.c
	rm -f ${BINS2} r2

SOURCES= main.c rabin2.c radare2.c radiff2.c rafind2.c
SOURCES+=rahash2.c rarun2.c rasm2.c rax2.c ragg2.c

build:
	mv main.c main.k
	mv version.c version.k
	rm -f *.[ch]
	mv main.k main.c
	mv version.k version.c
	for a in ${BINS2} ; do cp ../$$a/*.[ch] . ; done
	rm -f rwx.c xorhex.c rsc2.c
	for a in ${BINS2} ; do \
		mv $$a.c _$$a.c ;\
		sed -e "s,^int main,int $${a}_main,g" _$$a.c > $$a.c ; \
		rm -f _$$a ; \
	done
	rm -f _*
	${CC} -o radare2 ${SOURCES} ${CFLAGS} ${LDFLAGS}
	mv main.c main.k
	mv version.c version.k
	rm -f *.[ch]
	mv main.k main.c
	mv version.k version.c

install:
	mkdir -p ${DESTDIR}/${PREFIX}/bin
	for a in r2 ${BINS2} ; do \
		rm -f ${DESTDIR}/${PREFIX}/bin/$$a ; \
		cp -af $$a ${DESTDIR}/${PREFIX}/bin/$$a ; \
	done

=== binr/old.rarc2/Makefile ===
include ../../config-user.mk
include ../../libr/config.mk

CFLAGS+=-g -Wall
PFX=${DESTDIR}${PREFIX}

OBJS=rarc2.o emit_x86.o emit_x64.o emit_arm.o out.o

all: config.h rarc2${EXT_EXE}

config.h:
	cp -f config.def.h config.h

rarc2${EXT_EXE}: ${OBJS}
	${CC} ${LDFLAGS} -I. ${OBJS} -o rarc2${EXT_EXE}

osx:
	./rarc2 -ax86 osxtest.r > osxtest.asm
	rasm2 -a x86.olly -f osxtest.asm > osxtest.hex
	rabin2 -c mach0:$(shell cat osxtest.hex) osxtest

test:
	# only works with att mode
	./rarc2 t/hello.r > t/hello.S
	gcc t/hello.S -o t/hello
#	cat t/hello.S
	t/hello
	#spp test.r | ./rarc2
	#./rarc2 test.r

install:
	chmod +x rarc2
	mkdir -p ${PFX}/bin
	cp rarc2 ${PFX}/bin
	chmod +x rarc2-tool
	cp rarc2-tool ${PFX}/bin

install-symlink:
	mkdir -p ${PFX}/bin
	ln -fs ${PWD}/rarc2 ${PFX}/bin/rarc2
	ln -fs ${PWD}/rarc2-tool ${PFX}/bin/rarc2-tool

deinstall uninstall:
	rm -f ${PFX}/bin/rarc2 ${PFX}/bin/rarc2-tool

clean:
	cd t && ${MAKE} clean
	-rm -f rarc2 rarc2.o out.o emit*.o

mrproper: clean
	-rm -f config.h

.PHONY: all clean install install-symlink deinstall uninstall test mrproper

=== binr/r2agent/Makefile ===
BIN=r2agent
BINDEPS=r_socket r_cons r_util

include ../rules.mk

=== binr/rabin2/Makefile ===
BIN=rabin2
BINDEPS=r_lib r_magic r_core r_db r_bin r_egg r_cons
BINDEPS+=r_config r_io r_cmd r_flags r_asm
BINDEPS+=r_debug r_hash r_lang r_anal r_parse r_bp r_reg
BINDEPS+=r_search r_syscall r_sign r_diff r_socket r_fs r_magic r_util

include ../rules.mk

ifeq ($(OSTYPE),qnx)
LDFLAGS+=-lsocket
endif

=== binr/radare2/Makefile ===
BIN=radare2
BINDEPS=r_core r_parse r_search r_cons r_lib r_config
BINDEPS+=r_bin r_debug r_anal r_diff r_reg r_bp r_io r_cmd r_fs
BINDEPS+=r_sign r_lang r_asm r_syscall r_db r_hash
BINDEPS+=r_magic r_socket r_flags r_util r_egg r_crypto

include ../rules.mk
CFLAGS+=-DR2_GITTAP=\"$(GIT_TAP)\"

sign:
	ldid -Sradare2.xml radare2

osxsign:
	${CC} radare2.o ${CFLAGS} ${LDFLAGS} -o radare2 \
		-sectcreate __TEXT __info_plist ./Info.plist \
		-framework Security -framework CoreFoundation
	codesign -dvvv -s radare2 ./radare2
	sudo chown root:procmod radare2
	sudo chmod g+s radare2

ifeq ($(OSTYPE),android)
LDFLAGS+=${DL_LIBS} -lm
endif
ifeq ($(OSTYPE),qnx)
LDFLAGS+=-lsocket
endif

=== debian/changelog ===
radare2 (0.9.6-3.1ubuntu1) trusty; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Use autotools-dev to update config.{sub,guess} for new arches.

 -- Logan Rosen <logan@ubuntu.com>  Thu, 10 Apr 2014 12:38:27 -0400

radare2 (0.9.6-3.1) unstable; urgency=medium

  * debian/patches/12_fix_strcasestr_declaration: Add #define _GNU_SOURCE
    as well, to get the definition of strcasestr (closes: #735921).

 -- Steve McIntyre <93sam@debian.org>  Sun, 23 Mar 2014 14:38:44 +0000

radare2 (0.9.6-3ubuntu1) trusty; urgency=low

  * Use autotools-dev helper for newer arches.
  * Define missing macro so the strcasestr fix is actually used.

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 31 Mar 2014 15:26:56 -0400

radare2 (0.9.6-3) unstable; urgency=medium

  * debian/patches/12_fix_strcasestr_declaration: Fixed a missing include,
    thanks to Matthias Klose for pointing it (closes: #735921).

 -- David Martínez Moreno <ender@debian.org>  Tue, 28 Jan 2014 10:29:31 -0800

radare2 (0.9.6-2) unstable; urgency=low

  * debian/control: Switched Sebastian and myself as Maintainer/Uploader.
  * debian/patches/08_proper_tcc_build: Updated to fix a wrong ifeq in the
    Makefile.
  * debian/watch: Updated as it seems that pancake is releasing .tar.xz now.
  * debian/patches/01_fix-kfreebsd-compilation: Completely revamped from
    upstream commit 1941efc, to (hopefully) fix builds on kFreeBSD.
  * Added a lintian override for spelling-error-in-binary in libradare2-0.9.6,
    as it's invalid.

 -- David Martínez Moreno <ender@debian.org>  Fri, 17 Jan 2014 07:48:47 -0800

radare2 (0.9.6-1) unstable; urgency=low

  * New Year's release.  Just in time!
  * New upstream release.  Main changes are:
    - r2 now supports UTF-8, RGB and TrueColor ansi codes.
    - More platforms supported: ARM aarch64, TI c55x+, 8051, Javascript
      (emscripten), ARCcompact.
    - ASLR for PIE binaries is now supported by using the -B flag.
    - MACH0 XNU kernels are now properly loaded.
    - Added support for TE binaries.
    - Identify some PC BIOS and UEFI ROMs.
    - Java Class file parser has been rewritten to support Java7.
    - Python ctypes, D and Java JNI bindings.
    - An embedded webserver have been included, and you can invoke it using
      the `=h' or '=H' commands.
    - Improved JSON output for many commands. Just append 'j' to the command
      and it will use that format.
    - First release with an extensive test suite.
    - Lots of bugs has been fixed, overflows, memory leaks, and many
      handcrafted binaries can now be loaded without segfaults, crashes or
      lack of info (closes: #716192).
  * debian/patches:
    - 01_fix-kfreebsd-compilation: Refreshed.
    - 02_link-needed-libmagic: Fixed.
    - 03_unsafe_snprintf: New, partly taken from upstream commit 1289476 to
      fix an incomplete snprintf that was breaking the hardened build.
    - 04_remove_non-installable_library: New, to fix an extraneous t.0.9.6
      that was appearing in the builds.
    - 05_typos: Added, some typos and wrong man macros.
    - 06_no_forced_rpath: Added, disable rpath when --with-rpath is not
      present.
    - 07_propagate_ldflags: New, propagate LDFLAGS from environment into
      compilation by making assignment additive, fixing hardened builds.
    - 08_proper_tcc_build: Add .so as the default suffix of libr_tcc.
    - 09_fix_internal_plugins: New, fixed a bunch of problems with the
      internal bindings: made the lua check support Debian's lua, fixed
      library prefix, and removed ncurses bogus linking.
    - 10_fix_rafind2_segfault: New, backported from e0f4364 to fix a segfault
      reported by the Mayhem team (closes: #716503).
    - 11_block_libtcc_install: New, backported from upstream 1531e96 to stop
      installing libtcc files.
    - 101_split_plugins_installation: New, Debian-only, to ease packaging of
      the plugins.  Otherwise they ended up in libradare2.
  * debian/control:
    - Build-Depends on valabind (>> 0.7.4) and swig to generate internal
      plugins, plus python-dev and liblua5.2-dev for the corresponding
      extensions, and dh-exec to help with the packaging of radare2-plugins.
    - Updated descriptions.
    - Bumped Standards-Version to 3.9.5 (no changes).
    - Created another package (radare2-plugins) with the Python and Lua
      extensions (plus the dependency on Vala).
    - Make radare-plugins depend on valac; otherwise the vala extension is not
      functional.
  * debian/rules:
    - Fix a broken flag for configure (--without-debugger ->
      --disable-debugger) that was causing the debugger to be enabled back in
      several architectures where it was previously disabled, and thus breaking
      the builds (closes: #732853).
    - Force --fail-missing on dh_install to make sure that we don't miss new
      files in subsequent releases.
  * Removed the libradare2's symbols file because radare2 doesn't really try
    to have any sort of backwards compatibility.  It's futile to dump it from
    scratch in every release.

 -- David Martínez Moreno <ender@debian.org>  Tue, 31 Dec 2013 23:57:03 -0800

radare2 (0.9.4-2) unstable; urgency=low

  [ Sebastian Reichel ]
  * r_debug_desc_plugin_native is not available on some architectures,
    so make tag it accordingly in *.symbols file.
  * Add patch to fix compilation under GNU/kFreeBSD.

 -- David Martínez Moreno <ender@debian.org>  Tue, 10 Dec 2013 11:17:44 -0800

radare2 (0.9.4-1) unstable; urgency=low

  * New upstream release
  * Update debian/copyright
  * Bump Debian Standards Version 3.9.2 -> 3.9.4
  * Create new -common package for arch independent files

 -- Sebastian Reichel <sre@debian.org>  Sun, 22 Sep 2013 19:50:24 +0200

=== debian/control ===
Source: radare2
Section: devel
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: David Martínez Moreno <ender@debian.org>
Uploaders: Sebastian Reichel <sre@debian.org>
Build-Depends: debhelper (>= 9),
               autotools-dev,
               dh-exec (>= 0.3),
               quilt,
               flex,
               gobject-introspection,
               libgmp3-dev,
               libmagic-dev,
               swig,
               valabind (>> 0.7.4),
               valac,
               python-dev,
               liblua5.2-dev
Standards-Version: 3.9.5
Homepage: http://www.radare.org
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/radare2.git
Vcs-Git: git://anonscm.debian.org/collab-maint/radare2.git

Package: radare2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libradare2-dev
Description: free and advanced command line hexadecimal editor
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.

Package: radare2-plugins
Section: libs
Architecture: any
Depends: valac, ${misc:Depends}, ${shlibs:Depends}
Description: plugins for radare2
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the necessary libraries to run Python, Lua and Vala
 from within radare2.

Package: libradare2-0.9.6
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libradare2-common (>= ${source:Version})
Multi-Arch: same
Description: libraries from the radare2 suite
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the libraries from radare2.

Package: libradare2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libradare2-0.9.6 (= ${binary:Version}), libmagic-dev
Description: devel files from the radare2 suite
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the devel files from radare2.

Package: libradare2-0.9.6-dbg
Multi-Arch: same
Section: debug
Architecture: any
Depends: ${misc:Depends}, libradare2-0.9.6 (= ${binary:Version})
Description: debug symbols for libraries from radare suite
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the debug symbols for the libraries of radare2.

Package: libradare2-common
Multi-Arch: foreign
Architecture: all
Depends: ${misc:Depends}
Description: arch independent files from the radare2 suite
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the arch independent files from radare2.

=== debian/rules ===
#!/usr/bin/make -f
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEBUG_SUPPORT=0
EXTRA_FLAGS=--with-sysmagic

ifeq (arm,$(DEB_HOST_ARCH_CPU))
DEBUG_SUPPORT=1
endif

ifeq (amd64,$(DEB_HOST_ARCH_CPU))
DEBUG_SUPPORT=1
endif

ifeq (i386,$(DEB_HOST_ARCH_CPU))
DEBUG_SUPPORT=1
endif

ifeq (0,$(DEBUG_SUPPORT))
EXTRA_FLAGS+=--disable-debugger
endif

%:
	dh $@ --with autotools_dev

override_dh_auto_configure:
	./configure --prefix=/usr --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) ${EXTRA_FLAGS}

override_dh_makeshlibs:
	dh_makeshlibs --exclude=/usr/lib/$(DEB_HOST_MULTIARCH)/radare2/

override_dh_strip:
	dh_strip -pradare2 #--dbg-package=radare2-dbg
	dh_strip -pradare2-plugins
	dh_strip -plibradare2-0.9.6 --dbg-package=libradare2-0.9.6-dbg

override_dh_auto_install:
	dh_auto_install
	# remove "last" symlink
	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/radare2/last

override_dh_install:
	dh_install --fail-missing

override_dh_auto_clean:
	touch config-user.mk libr/config.mk
	-dh_auto_clean
	rm -f config-user.mk libr/config.mk

=== debian/watch ===
version=3
http://radare.org/get/radare2-([\d\.]+)\.tar\.xz
